//+------------------------------------------------------------------+
//|                                                     m_s_ind1.mq4 |
//|                                                     |
//|                     http://www.metaquotes.net (isq: 389-981-256) |
//+------------------------------------------------------------------+
#property copyright " "
#property link      "http://www.metaquotes.net (isq: 389-981-256)"


extern string gold="XAUUSD";
extern int period1=20;
extern int period2=5;

#property  indicator_separate_window
#property  indicator_buffers 1
#property  indicator_color1  Red

double A[],B[],C[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
 SetIndexStyle(0,DRAW_LINE,EMPTY,1,Red);
   SetIndexBuffer(0,A);
   SetIndexDrawBegin(0,0);
IndicatorBuffers(3);

SetIndexBuffer(1,B);
SetIndexBuffer(2,C);
//----
SetLevelStyle(STYLE_SOLID,1,Black);
SetLevelValue(0,0);

//----  
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
//----
   int    pos;
//---- main calculation loop
   
   if (iBars(gold,0)<=iBars(NULL,0)){pos=iBars(gold,0)-2;}
   else {pos=iBars(NULL,0)-2;}
   
   while(pos>=0)
     {
      if(pos==iBars("XAUUSD",0)-2) {
                                    B[pos+1]=iClose(NULL,0,pos+1)/iClose(gold,0,pos+1)*100;
                                    C[pos+1]=iClose(NULL,0,pos+1)/iClose(gold,0,pos+1)*100;
                                    }
     
      B[pos]=( (iClose(NULL,0,pos)/iClose(gold,0,pos)*100) *2.0/(period1+1)+B[pos+1]*(1-2.0/(period1+1)));
 	  	  
 	  	C[pos]=( (iClose(NULL,0,pos)/iClose(gold,0,pos)*100) *2.0/(period2+1)+C[pos+1]*(1-2.0/(period2+1)));
 	  
 	  
 	  A[pos]=B[pos]-C[pos];
 	  
 	   pos--;
     }

//----


   return(0);
  }
//+------------------------------------------------------------------+